Action Class Referenceabstract

`#include <Action.h>`

Inheritance diagram for Action:

## Public Member Functions

| Action (const char *name, const char *shortDescription, const char *description, bool acceptsNonParameter)
virtual | ~Action ()
const char * | getName () const
const char * | getShortDescription () const
const char * | getDescription () const
bool | acceptsNonParameter () const
virtual void | processNonParameter (const char *str)
virtual void | obtainParameters (vector< Parameter * > &parameters)
virtual void | parseCommandLine (unsigned int tokenCount, const char **tokens)
virtual void | perform ()=0
virtual bool | displayAction () const
| Returns whether this action should be shown to the user by the help action.
const Parameter & | getParam (const string &name) const

## Static Public Member Functions

static void | getActionNames (vector< string > &names)
static unique_ptr< Action > | createActionWithPrefix (const string &prefix)

## Protected Attributes

CliParams | _params
const char * | _name
const char * | _shortDescription
const char * | _description
bool | _acceptsNonParameter
BoolParameter | _printActions

## Detailed Description

Definition at line 25 of file Action.h.

## Constructor & Destructor Documentation

## Action()

Action::Action | ( | const char * | name,
|  | const char * | shortDescription,
|  | const char * | description,
|  | bool | acceptsNonParameter )

Definition at line 46 of file Action.cpp.

## ~Action()

Action::~Action | ( |  | ) |

virtual

Definition at line 59 of file Action.cpp.

## Member Function Documentation

## acceptsNonParameter()

bool Action::acceptsNonParameter | ( |  | ) | const

Definition at line 125 of file Action.cpp.

## createActionWithPrefix()

unique_ptr< Action > Action::createActionWithPrefix | ( | const string & | prefix | ) |

static

Definition at line 109 of file Action.cpp.

## displayAction()

bool Action::displayAction | ( |  | ) | const

virtual

Returns whether this action should be shown to the user by the help action.

Reimplemented in FrobeniusAction, HelpAction, LatticeAnalyzeAction, and TestAction.

Definition at line 97 of file Action.cpp.

## getActionNames()

void Action::getActionNames | ( | vector< string > & | names | ) |

static

Definition at line 105 of file Action.cpp.

## getDescription()

const char * Action::getDescription | ( |  | ) | const

Definition at line 121 of file Action.cpp.

## getName()

const char * Action::getName | ( |  | ) | const

Definition at line 113 of file Action.cpp.

## getParam()

const Parameter & Action::getParam | ( | const string & | name | ) | const

Definition at line 101 of file Action.cpp.

## getShortDescription()

const char * Action::getShortDescription | ( |  | ) | const

Definition at line 117 of file Action.cpp.

## obtainParameters()

void Action::obtainParameters | ( | vector< Parameter * > & | parameters | ) |

virtual

Reimplemented in AlexanderDualAction, AnalyzeAction, AssociatedPrimesAction, DimensionAction, DynamicFrobeniusAction, EulerAction, FrobeniusAction, GenerateFrobeniusAction, GenerateIdealAction, HelpAction, IntersectionAction, IrreducibleDecomAction, LatticeAnalyzeAction, LatticeFormatAction, MaximalStandardAction, OptimizeAction, PolyTransformAction, PrimaryDecomAction, TestAction, and TransformAction.

Definition at line 133 of file Action.cpp.

## parseCommandLine()

void Action::parseCommandLine | ( | unsigned int | tokenCount,
|  | const char ** | tokens )

virtual

Definition at line 137 of file Action.cpp.

## perform()

virtual void Action::perform | ( |  | ) |

pure virtual

Implemented in AlexanderDualAction, AnalyzeAction, AssociatedPrimesAction, DimensionAction, DynamicFrobeniusAction, EulerAction, FrobeniusAction, GenerateFrobeniusAction, GenerateIdealAction, HelpAction, HilbertAction, IntersectionAction, IrreducibleDecomAction, LatticeAnalyzeAction, LatticeFormatAction, MaximalStandardAction, OptimizeAction, PolyTransformAction, PrimaryDecomAction, TestAction, and TransformAction.

## processNonParameter()

void Action::processNonParameter | ( | const char * | str | ) |

virtual

Reimplemented in HelpAction.

Definition at line 129 of file Action.cpp.

## Member Data Documentation

## _acceptsNonParameter

bool Action::_acceptsNonParameter

protected

Definition at line 66 of file Action.h.

## _description

const char* Action::_description

protected

Definition at line 65 of file Action.h.

## _name

const char* Action::_name

protected

Definition at line 63 of file Action.h.

## _params

CliParams Action::_params

protected

Definition at line 59 of file Action.h.

## _printActions

BoolParameter Action::_printActions

protected

Definition at line 68 of file Action.h.

## _shortDescription

const char* Action::_shortDescription

protected

Definition at line 64 of file Action.h.

The documentation for this class was generated from the following files:

- src/Action.h
- src/Action.cpp